CREATE TABLE TL_ON_LINE_USER_QTY_LOG
(
	ON_LINE_USER_QTY_UUID VARCHAR(32)  NOT NULL ,
	LOG_TIME             TIMESTAMP  ,
	ADMIN_USER_QTY       integer   ,
	APP_USER_QTY         integer   ,
	UPDATE_CNT           integer   
)
;
ALTER TABLE TL_ON_LINE_USER_QTY_LOG
	ADD CONSTRAINT PK_ON_LINE_USER_QTY_LOG PRIMARY KEY   (ON_LINE_USER_QTY_UUID  )
;
	
CREATE INDEX IN_ONLINE_USER_LOG_TIME ON TL_ON_LINE_USER_QTY_LOG
(
	LOG_TIME              ASC
)  
;	

CREATE TABLE TL_SIGN_IN_LOG
(
	SIGN_IN_LOG_UUID     VARCHAR(32)  NOT NULL ,
	SIGN_IN_USER_UUID    VARCHAR(32 ),
	SIGN_IN_TIME         TIMESTAMP ,
	STATUS               integer   ,
	CUSTOMER_IP          varchar(200 ),
	UPDATE_CNT           integer   ,
	HTTP_SESSION_ID      varchar(1000)  
)
;
ALTER TABLE TL_SIGN_IN_LOG
	ADD CONSTRAINT PK_SIGN_IN_LOG PRIMARY KEY   (SIGN_IN_LOG_UUID )
;

--

CREATE INDEX IN_SIGN_IN_TIME ON TL_SIGN_IN_LOG
(
	SIGN_IN_TIME          ASC
)
;
CREATE TABLE TL_SIGN_OUT_LOG
(
	SIGN_OUT_LOG_UUID    VARCHAR(32)  NOT NULL ,
	SIGN_OUT_USER_UUID   VARCHAR(32 ),
	SIGN_OUT_TIME        TIMESTAMP ,
	CUSTOMER_IP          varchar(200 ),
	UPDATE_CNT           integer   ,
	HTTP_SESSION_ID      varchar(1000)  
)
;
ALTER TABLE TL_SIGN_OUT_LOG
	ADD CONSTRAINT PK_SIGN_OFF_LOG PRIMARY KEY   (SIGN_OUT_LOG_UUID )
;


CREATE INDEX IN_SIGN_OFF_TIME ON TL_SIGN_OUT_LOG
(
	SIGN_OUT_TIME         ASC
)
;

CREATE TABLE TL_SSO_SERVER_LOAD_LOG
(
	SSO_SERVER_LOAD_LOG_UUID VARCHAR(32)  NOT NULL ,
	LOG_TIME             TIMESTAMP ,
	CPU                  integer   ,
	JVM_AVAILABLE_MEMORY integer   ,
	JVM_USED_MEMORY      integer   ,
	UPDATE_CNT           integer   
)
;


ALTER TABLE TL_SSO_SERVER_LOAD_LOG
	ADD CONSTRAINT PK_SSO_SERVER_LOAD_LOG PRIMARY KEY   (SSO_SERVER_LOAD_LOG_UUID )
;


CREATE INDEX IN_SERVER_LOAD_LOG_TIME ON TL_SSO_SERVER_LOAD_LOG
(
	LOG_TIME              ASC
)
;
----------------------------
CREATE TABLE TL_WEB_REQUEST_BEGIN_LOG
(
	REQUEST_BEGIN_LOG_UUID VARCHAR(32)  NOT NULL ,
	START_TIME           TIMESTAMP ,
--	END_TIME             TIMESTAMP ,
	APP_UUID             VARCHAR(32 ),
	USER_UUID            VARCHAR(32 ),
	URL                  varchar(4000 ),
	URL_PARAMETER        varchar(4000 ),
	CUSTOMER_IP          varchar(200 ),
--	HTTP_REQUEST_DATA_SIZE integer   ,
	HTTP_REQUEST_TYPE    VARCHAR(100 ),
	SESSION_ID           varchar(32),
	UPDATE_CNT           integer   
)
;
----


ALTER TABLE TL_WEB_REQUEST_BEGIN_LOG
	ADD CONSTRAINT PK_WEB_REQUEST_BEGIN_LOG PRIMARY KEY   (REQUEST_BEGIN_LOG_UUID )
;


CREATE INDEX IN_REQUEST_START_TIME ON TL_WEB_REQUEST_BEGIN_LOG
(
	START_TIME            ASC
)
;

----------------------------
----------------------------
CREATE TABLE TL_WEB_REQUEST_END_LOG
(
	REQUEST_END_LOG_UUID VARCHAR(32)  NOT NULL ,
--	START_TIME           TIMESTAMP ,
	END_TIME             TIMESTAMP ,
--	APP_UUID             VARCHAR(32 ),
--	USER_UUID            VARCHAR(32 ),
--	URL                  varchar(4000 ),
--	URL_PARAMETER        varchar(4000 ),
--	CUSTOMER_IP          varchar(200 ),
	HTTP_REQUEST_DATA_SIZE integer   ,
--	HTTP_REQUEST_TYPE    VARCHAR(100 ),
--	SESSION_ID           varchar(32),
	UPDATE_CNT           integer   
)
;
----


ALTER TABLE TL_WEB_REQUEST_END_LOG
	ADD CONSTRAINT PK_WEB_REQUEST_END_LOG PRIMARY KEY   (REQUEST_END_LOG_UUID )
;


CREATE INDEX IN_REQUEST_END_TIME ON TL_WEB_REQUEST_END_LOG
(
	END_TIME            ASC
)
;

----------------------------
CREATE TABLE TL_WEB_RESPONSE_BEGIN_LOG
(
	RESPONSE_BEGIN_LOG_UUID VARCHAR(32)  NOT NULL ,
	START_TIME           TIMESTAMP ,
--	END_TIME             TIMESTAMP ,
	APP_UUID             VARCHAR(32 ),
--	HTTP_RESPONSE_DATA_SIZE integer   ,
	HTTP_RESPONSE_DATA_TYPE VARCHAR(100 ),
	HTTP_STATUS_CODE VARCHAR(100),
	UPDATE_CNT           integer   
)
;


ALTER TABLE TL_WEB_RESPONSE_BEGIN_LOG
	ADD CONSTRAINT PK_WEB_RESPONSE_BEGIN_LOG PRIMARY KEY   (RESPONSE_BEGIN_LOG_UUID )
;


CREATE INDEX IN_RESPONSE_START_TIME ON TL_WEB_RESPONSE_BEGIN_LOG
(
	START_TIME            ASC
)
;
----------------------------
----------------------------
CREATE TABLE TL_WEB_RESPONSE_END_LOG
(
	RESPONSE_END_LOG_UUID VARCHAR(32)  NOT NULL ,
--	START_TIME           TIMESTAMP ,
	END_TIME             TIMESTAMP ,
--	APP_UUID             VARCHAR(32 ),
	HTTP_RESPONSE_DATA_SIZE integer   ,
--	HTTP_RESPONSE_DATA_TYPE VARCHAR(100 ),
	UPDATE_CNT           integer   
)
;


ALTER TABLE TL_WEB_RESPONSE_END_LOG
	ADD CONSTRAINT PK_WEB_RESPONSE_END_LOG PRIMARY KEY   (RESPONSE_END_LOG_UUID )
;


CREATE INDEX IN_RESPONSE_END_TIME ON TL_WEB_RESPONSE_END_LOG
(
	END_TIME            ASC
)
;
----------------------------

CREATE TABLE TM_ADMIN_USER
(
	ADMIN_UUID           varchar(32)  NOT NULL ,
	ADMIN_SIGN_NM        varchar(20 ),
	ADMIN_FULL_NM        varchar(80 ),
	EMAIL                VARCHAR(255 ),
	PHONE                VARCHAR(2255 ),
	EFFECTIVE_DATE       TIMESTAMP NOT NULL,
	DISCARD_DATE         TIMESTAMP ,
	MEMO                 varchar(2000 ),
	CREATED_BY           varchar(20 ),
	CREATED_DT           TIMESTAMP ,
	UPDATED_BY           varchar(20 ),
	UPDATED_DT           TIMESTAMP ,
	UPDATE_CNT           integer   
)
;


ALTER TABLE TM_ADMIN_USER
	ADD CONSTRAINT PK_SSO_ADMIN PRIMARY KEY   (ADMIN_UUID )
;



CREATE TABLE TM_ADMIN_USER_CREDENTIAL
(
	ADMIN_UUID           VARCHAR(32)  NOT NULL ,
	ENCRYPTED_PASSWORD   varchar(255 ),
	CREATED_BY           varchar(20 ),
	CREATED_DT           TIMESTAMP ,
	UPDATED_BY           varchar(20 ),
	UPDATED_DT           TIMESTAMP ,
	UPDATE_CNT           integer   
)
;
-------------

ALTER TABLE TM_ADMIN_USER_CREDENTIAL
	ADD CONSTRAINT PK_TM_ADMIN_USER_CREDENTIAL PRIMARY KEY   (ADMIN_UUID )
;
--------
--ALTER TABLE [TM_ADMIN_USER_CREDENTIAL] 
--	ADD CONSTRAINT [R_3] FOREIGN KEY([ADMIN_UUID])REFERENCES [TM_ADMIN_USER] ([ADMIN_UUID])
--		ON DELETE NO ACTION
--		ON UPDATE NO ACTION
--;
--------
CREATE TABLE TM_APP_URL
(
	APP_URL_UUID         VARCHAR(32)  NOT NULL ,
	APP_UUID             VARCHAR(32 ),
	OPP_URL              varchar(255 ),
	MEMO              varchar(255 ),
	CREATED_BY           varchar(20 ),
	CREATED_DT           TIMESTAMP ,
	UPDATED_BY           varchar(20 ),
	UPDATED_DT           TIMESTAMP ,
	UPDATE_CNT           integer   
)
;


ALTER TABLE TM_APP_URL
	ADD CONSTRAINT PK_APP_PROGRAM_URL PRIMARY KEY   (APP_URL_UUID )
;

CREATE TABLE TM_APP_URL_GROUP
(
	APP_URL_GROUP_UUID   VARCHAR(32)  NOT NULL ,
	CREATED_BY           varchar(20 ),
	CREATED_DT           TIMESTAMP ,
	UPDATED_BY           varchar(20 ),
	UPDATED_DT           TIMESTAMP ,
	UPDATE_CNT           integer   ,
	URL_GROUP_NM         varchar(20 ),
	APP_UUID             VARCHAR(32)  
)
;


ALTER TABLE TM_APP_URL_GROUP
	ADD CONSTRAINT PK_APP_PROGRAM_URL_GROUP PRIMARY KEY   (APP_URL_GROUP_UUID )
;
CREATE TABLE TM_APP_USER
(
	APP_USER_UUID        varchar(32)  NOT NULL ,
	USER_SIGN_IN_NM      varchar(20 ),
	USER_FULL_NM         varchar(80 ),
	EMAIL                varchar(255 ),
	PHONE                varchar(255 ),
	EFFECTIVE_DATE       TIMESTAMP NOT NULL,
	DISCARD_DATE         TIMESTAMP ,
	MEMO                 varchar(2000 ),
	CREATED_BY           varchar(20 ),
	CREATED_DT           TIMESTAMP ,
	UPDATED_BY           varchar(20 ),
	UPDATED_DT           TIMESTAMP ,
	UPDATE_CNT           integer   
)
;


ALTER TABLE TM_APP_USER
	ADD CONSTRAINT PK_APP_USER PRIMARY KEY   (APP_USER_UUID )
;

CREATE TABLE TM_APP_USER_CREDENTIAL
(
	APP_USER_UUID        VARCHAR(32)  NOT NULL ,
	ENCRYPTED_PASSWORD   varchar(255 ),
	CREATED_BY           varchar(20 ),
	CREATED_DT           TIMESTAMP ,
	UPDATED_BY           varchar(20 ),
	UPDATED_DT           TIMESTAMP ,
	UPDATE_CNT           integer   
)
;

-------------
ALTER TABLE TM_APP_USER_CREDENTIAL
	ADD CONSTRAINT PK_TM_APP_USER_CREDENTIAL PRIMARY KEY   (APP_USER_UUID )
;

--ALTER TABLE TM_APP_USER_CREDENTIAL
--	ADD  CONSTRAINT FK_APP_USER_CREDENTIALS FOREIGN KEY(APP_USER_UUID) REFERENCES TM_APP_USER (APP_USER_UUID)
--		ON DELETE NO ACTION
--		ON UPDATE NO ACTION
--;
--------
CREATE TABLE TM_APPLICATION
(
	APP_UUID             VARCHAR(32)  NOT NULL ,
	APP_ABBREVIATION_NM  VARCHAR(50 ),
	APP_FULL_NM          VARCHAR(80 ),
	APP_ROOT_URL         varchar(2000 ),
	REMOTE_USER_KEY_IN_REQ_HEADER varchar(1000) ,
	REMOTE_IP_KEY_IN_REQ_HEADER varchar(1000) ,
	USE_SSO_AUTHORITY_FLAG integer default 0,
	NEED_USER_SIGN_IN_FLAG integer default 1,
	SESSION_TIME_OUT_SECONDS     integer   ,
	IP_ACCESS_RULE_USE_ORDER integer   ,
	MEMO                 VARCHAR(255)  ,
	CREATED_DT           TIMESTAMP ,
	CREATED_BY           varchar(20 ),
	UPDATED_BY           varchar(20 ),
	UPDATED_DT           TIMESTAMP ,
	UPDATE_CNT           integer   
)
;


ALTER TABLE TM_APPLICATION
	ADD CONSTRAINT PK_APPLICATION PRIMARY KEY   (APP_UUID )
;
CREATE TABLE TT_BINARY_DATA
(
	BIN_UUID             VARCHAR(32)  NOT NULL ,
	BIN_CONTENT          BLOB ,
	CREATED_DT           TIMESTAMP ,
	CREATED_BY           varchar(20 ),
	UPDATED_BY           varchar(20 ),
	UPDATED_DT           TIMESTAMP ,
	UPDATE_CNT           integer   
)
;


ALTER TABLE TT_BINARY_DATA
	ADD CONSTRAINT PK_BINARY_DATA PRIMARY KEY   (BIN_UUID )
;
CREATE TABLE TT_BINARY_DATA_INFO
(
	BIN_SIZE             integer   ,
	FILE_NAME            VARCHAR(255 ),
	DATA_TYPE            VARCHAR(40 ),
	MEMO                 VARCHAR(255 ),
	CREATED_BY           VARCHAR(20 ),
	CREATED_DT           TIMESTAMP ,
	UPDATED_BY           VARCHAR(20 ),
	UPDATED_DT           TIMESTAMP ,
	UPDATE_CNT          integer   ,
	BIN_UUID             VARCHAR(32)  NOT NULL 
)
;


ALTER TABLE TT_BINARY_DATA_INFO
	ADD CONSTRAINT PK_BINARY_DATA_INFO PRIMARY KEY   (BIN_UUID )
;

CREATE TABLE TM_IP_ACCESS_RULE
(
	IP_ACCESS_RULE_UUID  VARCHAR(32)  NOT NULL ,
	APP_UUID             VARCHAR(32 ),
	IP_RANGE_PATTERN     VARCHAR(2000 ),
	CREATED_BY           varchar(20 ),
	CREATED_DT           TIMESTAMP ,
	UPDATED_BY           varchar(20 ),
	UPDATED_DT           TIMESTAMP ,
	UPDATE_CNT           integer   ,
	ALLOW_ACCESS_FLAG    integer   ,
	MEMO                 VARCHAR(255)  
)
;


ALTER TABLE TM_IP_ACCESS_RULE
	ADD CONSTRAINT PK_IP_ACCESS_RULE PRIMARY KEY   (IP_ACCESS_RULE_UUID )
;

CREATE TABLE TM_STRING_REPLACE_RULE
(
	STRING_REPLACE_RULE_UUID VARCHAR(32)  NOT NULL ,
	PAGE_CHARACTER_CODE  varchar(20 ),
	CREATED_BY           varchar(20 ),
	CREATED_DT           TIMESTAMP ,
	UPDATED_BY           varchar(20 ),
	UPDATED_DT           TIMESTAMP ,
	UPDATE_CNT           integer   ,
	MATCHED_URL_PATTERN  VARCHAR(255 ),
	STR_BEFORE_REPLACE   VARCHAR(255 ),
	STR_AFTER_REPLACE    VARCHAR(255 ),
	MEMO                 VARCHAR(255)  
)
;


ALTER TABLE TM_STRING_REPLACE_RULE
	ADD CONSTRAINT PK_URL_REPLACE_RULE PRIMARY KEY   (STRING_REPLACE_RULE_UUID )
;
CREATE TABLE TR_APP_USER_APP
(
	APP_USER_APP_UUID    varchar(32)  NOT NULL ,
	APP_UUID             VARCHAR(32 ),
	APP_USER_UUID        varchar(32 ),
	CREATED_BY           varchar(20 ),
	CREATED_DT           TIMESTAMP ,
	UPDATED_BY           varchar(20 ),
	UPDATED_DT           TIMESTAMP ,
	UPDATE_CNT           integer   
)
;


ALTER TABLE TR_APP_USER_APP
	ADD CONSTRAINT PK_APP_USER_APP PRIMARY KEY   (APP_USER_APP_UUID )
;
CREATE TABLE TR_URL_GROUP_MEMBER
(
	URL_GROUP_MEMBER_UUID VARCHAR(32)  NOT NULL ,
	APP_URL_GROUP_UUID   VARCHAR(32 ),
	APP_URL_UUID         VARCHAR(32 ),
	CREATED_BY           varchar(20 ),
	CREATED_DT           TIMESTAMP ,
	UPDATED_BY           varchar(20 ),
	UPDATED_DT           TIMESTAMP ,
	UPDATE_CNT           integer   
)
;


ALTER TABLE TR_URL_GROUP_MEMBER
	ADD CONSTRAINT PK_URL_GROUP_MEMBER PRIMARY KEY   (URL_GROUP_MEMBER_UUID )
;
CREATE TABLE TR_USER_URL_GROUP
(
	USER_URL_GROUP_UUID  varchar(32)  NOT NULL ,
	APP_URL_GROUP_UUID   VARCHAR(32 ),
	CREATED_BY           varchar(20 ),
	CREATED_DT           TIMESTAMP ,
	UPDATED_BY           varchar(20 ),
	UPDATED_DT           TIMESTAMP ,
	UPDATE_CNT           integer   ,
	APP_USER_UUID        varchar(32)  
)
;


ALTER TABLE TR_USER_URL_GROUP
	ADD CONSTRAINT PK_USER_URL_GROUP PRIMARY KEY   (USER_URL_GROUP_UUID )
;

CREATE TABLE TS_MULTI_LANGUAGE_RESOURCE
(
	MSG_KEY              VARCHAR(255)  NOT NULL ,
	MSG_VAL              VARCHAR(2000 ),
	LOCALE               varchar(20 ),
	UPDATE_CNT           integer  default 0 
)
;


--ALTER TABLE TS_MULTI_LANGUAGE_RESOURCE
--	ADD CONSTRAINT PK_VW_APP_RESOURCES PRIMARY KEY   (MSG_KEY )
--;

CREATE TABLE TS_SSO_CONFIG_DATA
(
	CONFIG_KEY           varchar(255)  NOT NULL ,
	CONFIG_VALUE         varchar(255 ),
	CREATED_BY           varchar(20 ),
	CREATED_DT           TIMESTAMP ,
	UPDATED_BY           varchar(20 ),
	UPDATED_DT           TIMESTAMP ,
	UPDATE_CNT           integer   ,
	DESC_MULTI_LANG_KEY  VARCHAR(255)  
)
;

-----
ALTER TABLE TS_SSO_CONFIG_DATA
	ADD CONSTRAINT PK_TS_SSO_CONFIG_DATA PRIMARY KEY   (CONFIG_KEY )
;

--GOOD
CREATE TABLE TL_APP_ERR_LOG
(
	APP_ERR_LOG_UUID         VARCHAR(32)  NOT NULL ,
	CREATED_BY           varchar(20 ),
	CREATED_DT           TIMESTAMP ,
	UPDATED_BY           varchar(20 ),
	UPDATED_DT           TIMESTAMP ,
	UPDATE_CNT           integer   ,
	ERR_FUNCTION_MODULE  VARCHAR(256 ),
	ERR_DESC             VARCHAR(2000 ),
	REQUEST_BEGIN_LOG_UUID VARCHAR(32)  
)
;


ALTER TABLE TL_APP_ERR_LOG
	ADD CONSTRAINT PK_APP_ERR_LOG PRIMARY KEY   (APP_ERR_LOG_UUID )
;


CREATE TABLE TS_LICENSE
(
	LICENSE_UUID         varchar(32)  NOT NULL ,
	SSO_USER_COUNT       integer  NOT NULL ,
	PURCHASE_DATE        TIMESTAMP  NOT NULL ,
	MEMO              varchar(255 ),
	CREATED_BY           varchar(20 ),
	CREATED_DT           TIMESTAMP ,
	UPDATED_BY           varchar(20 ),
	UPDATED_DT           TIMESTAMP ,
	UPDATE_CNT           integer   
)
;


ALTER TABLE TS_LICENSE
	ADD CONSTRAINT PK_LICENSE PRIMARY KEY   (LICENSE_UUID )
;


--CREATE INDEX IN_CREATED_DT ON TL_APP_ERR_LOG
--(
--	CREATED_DT            ASC
--)
--;
ALTER TABLE TR_APP_USER_APP
	ADD CONSTRAINT  FK_APP_USER_APP_APP_USER_UUID FOREIGN KEY (APP_USER_UUID) REFERENCES TM_APP_USER(APP_USER_UUID)
		ON DELETE NO ACTION
		ON UPDATE NO ACTION
;

ALTER TABLE TR_APP_USER_APP
	ADD CONSTRAINT  FK_APP_USER_APP_APP_UUID FOREIGN KEY (APP_UUID) REFERENCES TM_APPLICATION(APP_UUID)
		ON DELETE NO ACTION
		ON UPDATE NO ACTION
;
ALTER TABLE TR_URL_GROUP_MEMBER
	ADD CONSTRAINT  FK_URL_GROUP_MEMBER_APP_URL_UUID FOREIGN KEY (APP_URL_UUID) REFERENCES TM_APP_URL(APP_URL_UUID)
		ON DELETE NO ACTION
		ON UPDATE NO ACTION
;

ALTER TABLE TR_URL_GROUP_MEMBER
	ADD CONSTRAINT  FK_URL_GROUP_MEMBER_APP_URL_GROUP_UUID FOREIGN KEY (APP_URL_GROUP_UUID) REFERENCES TM_APP_URL_GROUP(APP_URL_GROUP_UUID)
		ON DELETE NO ACTION
		ON UPDATE NO ACTION
;
--ALTER TABLE TR_USER_URL_GROUP
--	ADD CONSTRAINT  FK_USER_URL_GROUP_APP_URL_GROUP_UUID FOREIGN KEY (APP_URL_GROUP_UUID) REFERENCES TM_APP_URL_GROUP(APP_URL_GROUP_UUID)
--		ON DELETE NO ACTION
--		ON UPDATE NO ACTION
--;

ALTER TABLE TR_USER_URL_GROUP
	ADD CONSTRAINT  FK_USER_URL_GROUP_APP_USER_UUID FOREIGN KEY (APP_USER_UUID) REFERENCES TM_APP_USER(APP_USER_UUID)
		ON DELETE NO ACTION
		ON UPDATE NO ACTION
;

--ALTER TABLE TM_ADMIN_USER_CREDENTIAL
--	ADD CONSTRAINT FK_ADMIN_USER_CREDENTIALS_ADMIN_USER_UUID FOREIGN KEY(ADMIN_UUID)REFERENCES TM_ADMIN_USER (ADMIN_UUID)
--		ON DELETE NO ACTION
--		ON UPDATE NO ACTION
--;

--2010/12/21

CREATE TABLE TS_LICENSE_DATA
(
	LICENSE_DATA_UUID     varchar(32)  NOT NULL ,
	LICENSE_DATA_STR      varchar(4000)  NOT NULL ,
	CREATED_BY            varchar(20)   ,
	CREATED_DT            TIMESTAMP,
	UPDATED_BY            varchar(20)   ,
	UPDATED_DT            TIMESTAMP,
	UPDATE_CNT            INTEGER
);
ALTER TABLE TS_LICENSE_DATA
	ADD CONSTRAINT  PK_LICENSE_DATA PRIMARY KEY (LICENSE_DATA_UUID);
----
